<?php

namespace EMS\PortalFuncionario\Geral\Services;

use EMS\PortalFuncionario\Util\HcmServices;

class AvaliacaoService {
    /** @var HcmServices */
    protected $hcmServices;

    public function __construct(
        HcmServices $hcmServices
    ) {
        $this->hcmServices = $hcmServices;
    }

    public function getAvaliacoes(
        int $nrOrg,
        string $cdOperador
    ): array {
        $route = 'getAvaliacoes';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'CDOPERADOR' => $cdOperador,
            ],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $avaliacoes = $result['dataset'][$route];

        return $avaliacoes;
    }

    public function getQuestoesAvaliacao(
        array $row
    ): array {
        $nrOrg = (int) $row['NRORG'];
        $route = 'getQuestoesAvaliacao';

        $params = [
            'requestType' => 'Row',
            'row' => $row,
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $questoes = $result['dataset'][$route];

        return $questoes;
    }

    public function salvarAvaliacao(
        array $row
    ): bool {
        $nrOrg = (int) $row['NRORG'];
        $route = 'salvarAvaliacao';

        $params = [
            'requestType' => 'Row',
            'row' => $row,
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $success = $result['dataset'][$route]['success'];

        return $success;
    }
}