<?php
namespace EMS\PortalFuncionario\Geral\Services;

use EMS\PortalFuncionario\Util\HcmServices;

class EnderecoService {

    /** @var HcmServices */
    protected $hcmServices;

    public function __construct(
        HcmServices $hcmServices
    ) {
        $this->hcmServices = $hcmServices;
    }

    public function pesquisarCep(
        int $nrOrg,
        string $cep
    ): array {
        $hcmServicesRoute = 'pesquisarCep';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'CEP' => $cep
            ]
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $status = (array) $response['dataset'][$hcmServicesRoute];

        return $status;
    }
}
