/* Tabela LOJA: TABELA DE LOJA*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela LOJA */
/* Objetivo: Gerar um log que vai registrar as alteraes na LOJA,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_LOJA' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID                 AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_LOJA
GO

CREATE TRIGGER LOG_VND_LOJA
ON LOJA
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);
  
  DECLARE @V_OLD_CDFILIAL            varchar(4);
  DECLARE @V_OLD_CDLOJA              varchar(10);
  DECLARE @V_OLD_NMLOJA              varchar(50);
  DECLARE @V_OLD_DSDIRUNIARQ         varchar(200);
  DECLARE @V_OLD_IDCONTCVALE         varchar(1);
  DECLARE @V_OLD_CDALMOXARIFE        varchar(6);
  DECLARE @V_OLD_CDLOCALESTOQ        varchar(6);
  DECLARE @V_OLD_IDTIPOIMPDEL        varchar(1);
  DECLARE @V_OLD_IDPORTIMPDEL        varchar(1);
  DECLARE @V_OLD_IDEXPORTCDS         varchar(1);
  DECLARE @V_OLD_NRDIAVALCVAL        varchar(3);
  DECLARE @V_OLD_CDTABEPREC          varchar(3);
  DECLARE @V_OLD_NRMESAPADRAO        varchar(4);
  DECLARE @V_OLD_CDVENDPADRAO        varchar(4);
  DECLARE @V_OLD_CDPRODCOUVER        varchar(10);
  DECLARE @V_OLD_CDPRODCONSUM        varchar(10);
  DECLARE @V_OLD_CDCLIENTERAT        varchar(21);
  DECLARE @V_OLD_IDCOMISVENDA        varchar(1);
  DECLARE @V_OLD_VRCOMISVENDA        double precision;
  DECLARE @V_OLD_IDCOMANDAVEN        varchar(1);
  DECLARE @V_OLD_IDCOUVERART         varchar(1);
  DECLARE @V_OLD_IDCONSUMAMIN        varchar(1);
  DECLARE @V_OLD_IDLUGARMESA         varchar(1);
  DECLARE @V_OLD_IDRATEIOCOMI        varchar(1);
  DECLARE @V_OLD_NRMINSEMCONS        varchar(2);
  DECLARE @V_OLD_IDUTIVENDPAD        varchar(1);
  DECLARE @V_OLD_IDCONTROPROD        varchar(1);
  DECLARE @V_OLD_CDLOJMESPADR        varchar(10);
  DECLARE @V_OLD_CDPRODCOMVEN        varchar(10);
  DECLARE @V_OLD_CDGRPOCORPED        varchar(2);
  DECLARE @V_OLD_CDGRPOCORCAN        varchar(2);
  DECLARE @V_OLD_IDSOLOBSPED         varchar(1);
  DECLARE @V_OLD_IDSOLOBSCAN         varchar(1);
  DECLARE @V_OLD_DTULTATULOJA        datetime;
  DECLARE @V_OLD_CDPRODCONSUF        varchar(10);
  DECLARE @V_OLD_IDTIPCOBRA          varchar(1);
  DECLARE @V_OLD_CDCENTCUST          varchar(4);
  DECLARE @V_OLD_IDINFMESACOM        char(1);
  DECLARE @V_OLD_IDINFCONSCOM        char(1);
  DECLARE @V_OLD_IDINFVENDCOM        char(1);
  DECLARE @V_OLD_IDCOMANDAAUT        char(1);
  DECLARE @V_OLD_IDPOSOBSPED         varchar(1);
  DECLARE @V_OLD_IDBLOQCOMPARC       varchar(1);
  DECLARE @V_OLD_IDIMPCNPJCLIE       varchar(1);
  DECLARE @V_OLD_IDUTLSENHAOPER      varchar(1);
  DECLARE @V_OLD_IDIMPRCUPTEFRED     varchar(1);
  DECLARE @V_OLD_IDIMPCUPTROCA       varchar(1);
  DECLARE @V_OLD_NRDIASCUPTROCA      double precision;
  DECLARE @V_OLD_IDEXIBEMENSOP       varchar(1); 
  DECLARE @V_OLD_DSMENSOPERLOJA      varchar(255);

  DECLARE @V_NEW_CDFILIAL            varchar(4);
  DECLARE @V_NEW_CDLOJA              varchar(10);
  DECLARE @V_NEW_NMLOJA              varchar(50);
  DECLARE @V_NEW_DSDIRUNIARQ         varchar(200);
  DECLARE @V_NEW_IDCONTCVALE         varchar(1);
  DECLARE @V_NEW_CDALMOXARIFE        varchar(6);
  DECLARE @V_NEW_CDLOCALESTOQ        varchar(6);
  DECLARE @V_NEW_IDTIPOIMPDEL        varchar(1);
  DECLARE @V_NEW_IDPORTIMPDEL        varchar(1);
  DECLARE @V_NEW_IDEXPORTCDS         varchar(1);
  DECLARE @V_NEW_NRDIAVALCVAL        varchar(3);
  DECLARE @V_NEW_CDTABEPREC          varchar(3);
  DECLARE @V_NEW_NRMESAPADRAO        varchar(4);
  DECLARE @V_NEW_CDVENDPADRAO        varchar(4);
  DECLARE @V_NEW_CDPRODCOUVER        varchar(10);
  DECLARE @V_NEW_CDPRODCONSUM        varchar(10);
  DECLARE @V_NEW_CDCLIENTERAT        varchar(21);
  DECLARE @V_NEW_IDCOMISVENDA        varchar(1);
  DECLARE @V_NEW_VRCOMISVENDA        double precision;
  DECLARE @V_NEW_IDCOMANDAVEN        varchar(1);
  DECLARE @V_NEW_IDCOUVERART         varchar(1);
  DECLARE @V_NEW_IDCONSUMAMIN        varchar(1);
  DECLARE @V_NEW_IDLUGARMESA         varchar(1);
  DECLARE @V_NEW_IDRATEIOCOMI        varchar(1);
  DECLARE @V_NEW_NRMINSEMCONS        varchar(2);
  DECLARE @V_NEW_IDUTIVENDPAD        varchar(1);
  DECLARE @V_NEW_IDCONTROPROD        varchar(1);
  DECLARE @V_NEW_CDLOJMESPADR        varchar(10);
  DECLARE @V_NEW_CDPRODCOMVEN        varchar(10);
  DECLARE @V_NEW_CDGRPOCORPED        varchar(2);
  DECLARE @V_NEW_CDGRPOCORCAN        varchar(2);
  DECLARE @V_NEW_IDSOLOBSPED         varchar(1);
  DECLARE @V_NEW_IDSOLOBSCAN         varchar(1);
  DECLARE @V_NEW_DTULTATULOJA        datetime;
  DECLARE @V_NEW_CDPRODCONSUF        varchar(10);
  DECLARE @V_NEW_IDTIPCOBRA          varchar(1);
  DECLARE @V_NEW_CDCENTCUST          varchar(4);
  DECLARE @V_NEW_IDINFMESACOM        char(1);
  DECLARE @V_NEW_IDINFCONSCOM        char(1);
  DECLARE @V_NEW_IDINFVENDCOM        char(1);
  DECLARE @V_NEW_IDCOMANDAAUT        char(1);
  DECLARE @V_NEW_IDPOSOBSPED         varchar(1);
  DECLARE @V_NEW_IDBLOQCOMPARC       varchar(1);
  DECLARE @V_NEW_IDIMPCNPJCLIE       varchar(1);
  DECLARE @V_NEW_IDUTLSENHAOPER      varchar(1);
  DECLARE @V_NEW_IDIMPRCUPTEFRED     varchar(1);
  DECLARE @V_NEW_IDIMPCUPTROCA       varchar(1);
  DECLARE @V_NEW_NRDIASCUPTROCA      double precision;
  DECLARE @V_NEW_IDEXIBEMENSOP       varchar(1); 
  DECLARE @V_NEW_DSMENSOPERLOJA      varchar(255);


BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;
   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,               
           DELETED.CDFILIAL,
           DELETED.CDLOJA,
           DELETED.NMLOJA,
           DELETED.DSDIRUNIARQ,
           DELETED.IDCONTCVALE,
           DELETED.CDALMOXARIFE,
           DELETED.CDLOCALESTOQ,
           DELETED.IDTIPOIMPDEL,
           DELETED.IDPORTIMPDEL,
           DELETED.IDEXPORTCDS,
           DELETED.NRDIAVALCVAL,
           DELETED.CDTABEPREC,
           DELETED.NRMESAPADRAO,
           DELETED.CDVENDPADRAO,
           DELETED.CDPRODCOUVER,
           DELETED.CDPRODCONSUM,
           DELETED.CDCLIENTERAT,
           DELETED.IDCOMISVENDA,
           DELETED.VRCOMISVENDA,
           DELETED.IDCOMANDAVEN,
           DELETED.IDCOUVERART,
           DELETED.IDCONSUMAMIN,
           DELETED.IDLUGARMESA,
           DELETED.IDRATEIOCOMI,
           DELETED.NRMINSEMCONS,
           DELETED.IDUTIVENDPAD,
           DELETED.IDCONTROPROD,
           DELETED.CDLOJMESPADR,
           DELETED.CDPRODCOMVEN,
           DELETED.CDGRPOCORPED,
           DELETED.CDGRPOCORCAN,
           DELETED.IDSOLOBSPED,
           DELETED.IDSOLOBSCAN,
           DELETED.DTULTATULOJA,
           DELETED.CDPRODCONSUF,
           DELETED.IDTIPCOBRA,
           DELETED.CDCENTCUST,
           DELETED.IDINFMESACOM,
           DELETED.IDINFCONSCOM,
           DELETED.IDINFVENDCOM,
           DELETED.IDCOMANDAAUT,
           DELETED.IDPOSOBSPED,
           DELETED.IDBLOQCOMPARC,
           DELETED.IDIMPCNPJCLIE,
           DELETED.IDUTLSENHAOPER,
           DELETED.IDIMPRCUPTEFRED,
           DELETED.IDIMPCUPTROCA,
           DELETED.NRDIASCUPTROCA,
           DELETED.IDEXIBEMENSOP,
           DELETED.DSMENSOPERLOJA,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
     	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
 	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
    	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL

     FROM
           DELETED
     WHERE     
           DELETED.CDFILIAL+DELETED.CDLOJA NOT IN (SELECT CDFILIAL+CDLOJA FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           DELETED.CDFILIAL,
           DELETED.CDLOJA,
           DELETED.NMLOJA,
           DELETED.DSDIRUNIARQ,
           DELETED.IDCONTCVALE,
           DELETED.CDALMOXARIFE,
           DELETED.CDLOCALESTOQ,
           DELETED.IDTIPOIMPDEL,
           DELETED.IDPORTIMPDEL,
           DELETED.IDEXPORTCDS,
           DELETED.NRDIAVALCVAL,
           DELETED.CDTABEPREC,
           DELETED.NRMESAPADRAO,
           DELETED.CDVENDPADRAO,
           DELETED.CDPRODCOUVER,
           DELETED.CDPRODCONSUM,
           DELETED.CDCLIENTERAT,
           DELETED.IDCOMISVENDA,
           DELETED.VRCOMISVENDA,
           DELETED.IDCOMANDAVEN,
           DELETED.IDCOUVERART,
           DELETED.IDCONSUMAMIN,
           DELETED.IDLUGARMESA,
           DELETED.IDRATEIOCOMI,
           DELETED.NRMINSEMCONS,
           DELETED.IDUTIVENDPAD,
           DELETED.IDCONTROPROD,
           DELETED.CDLOJMESPADR,
           DELETED.CDPRODCOMVEN,
           DELETED.CDGRPOCORPED,
           DELETED.CDGRPOCORCAN,
           DELETED.IDSOLOBSPED,
           DELETED.IDSOLOBSCAN,
           DELETED.DTULTATULOJA,
           DELETED.CDPRODCONSUF,
           DELETED.IDTIPCOBRA,
           DELETED.CDCENTCUST,
           DELETED.IDINFMESACOM,
           DELETED.IDINFCONSCOM,
           DELETED.IDINFVENDCOM,
           DELETED.IDCOMANDAAUT,
           DELETED.IDPOSOBSPED,
           DELETED.IDBLOQCOMPARC,
           DELETED.IDIMPCNPJCLIE,
           DELETED.IDUTLSENHAOPER,
           DELETED.IDIMPRCUPTEFRED,
           DELETED.IDIMPCUPTROCA,
           DELETED.NRDIASCUPTROCA,
           DELETED.IDEXIBEMENSOP,
           DELETED.DSMENSOPERLOJA,

           INSERTED.CDFILIAL,
           INSERTED.CDLOJA,
           INSERTED.NMLOJA,
           INSERTED.DSDIRUNIARQ,
           INSERTED.IDCONTCVALE,
           INSERTED.CDALMOXARIFE,
           INSERTED.CDLOCALESTOQ,
           INSERTED.IDTIPOIMPDEL,
           INSERTED.IDPORTIMPDEL,
           INSERTED.IDEXPORTCDS,
           INSERTED.NRDIAVALCVAL,
           INSERTED.CDTABEPREC,
           INSERTED.NRMESAPADRAO,
           INSERTED.CDVENDPADRAO,
           INSERTED.CDPRODCOUVER,
           INSERTED.CDPRODCONSUM,
           INSERTED.CDCLIENTERAT,
           INSERTED.IDCOMISVENDA,
           INSERTED.VRCOMISVENDA,
           INSERTED.IDCOMANDAVEN,
           INSERTED.IDCOUVERART,
           INSERTED.IDCONSUMAMIN,
           INSERTED.IDLUGARMESA,
           INSERTED.IDRATEIOCOMI,
           INSERTED.NRMINSEMCONS,
           INSERTED.IDUTIVENDPAD,
           INSERTED.IDCONTROPROD,
           INSERTED.CDLOJMESPADR,
           INSERTED.CDPRODCOMVEN,
           INSERTED.CDGRPOCORPED,
           INSERTED.CDGRPOCORCAN,
           INSERTED.IDSOLOBSPED,
           INSERTED.IDSOLOBSCAN,
           INSERTED.DTULTATULOJA,
           INSERTED.CDPRODCONSUF,
           INSERTED.IDTIPCOBRA,
           INSERTED.CDCENTCUST,
           INSERTED.IDINFMESACOM,
           INSERTED.IDINFCONSCOM,
           INSERTED.IDINFVENDCOM,
           INSERTED.IDCOMANDAAUT,
           INSERTED.IDPOSOBSPED,
           INSERTED.IDBLOQCOMPARC,
           INSERTED.IDIMPCNPJCLIE,
           INSERTED.IDUTLSENHAOPER,
           INSERTED.IDIMPRCUPTEFRED,
           INSERTED.IDIMPCUPTROCA,
           INSERTED.NRDIASCUPTROCA,
           INSERTED.IDEXIBEMENSOP,
           INSERTED.DSMENSOPERLOJA
     FROM
           DELETED,
     	   INSERTED
     WHERE     
           INSERTED.CDFILIAL = DELETED.CDFILIAL AND
           INSERTED.CDLOJA   = DELETED.CDLOJA
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
 	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,

           INSERTED.CDFILIAL,
           INSERTED.CDLOJA,
           INSERTED.NMLOJA,
           INSERTED.DSDIRUNIARQ,
           INSERTED.IDCONTCVALE,
           INSERTED.CDALMOXARIFE,
           INSERTED.CDLOCALESTOQ,
           INSERTED.IDTIPOIMPDEL,
           INSERTED.IDPORTIMPDEL,
           INSERTED.IDEXPORTCDS,
           INSERTED.NRDIAVALCVAL,
           INSERTED.CDTABEPREC,
           INSERTED.NRMESAPADRAO,
           INSERTED.CDVENDPADRAO,
           INSERTED.CDPRODCOUVER,
           INSERTED.CDPRODCONSUM,
           INSERTED.CDCLIENTERAT,
           INSERTED.IDCOMISVENDA,
           INSERTED.VRCOMISVENDA,
           INSERTED.IDCOMANDAVEN,
           INSERTED.IDCOUVERART,
           INSERTED.IDCONSUMAMIN,
           INSERTED.IDLUGARMESA,
           INSERTED.IDRATEIOCOMI,
           INSERTED.NRMINSEMCONS,
           INSERTED.IDUTIVENDPAD,
           INSERTED.IDCONTROPROD,
           INSERTED.CDLOJMESPADR,
           INSERTED.CDPRODCOMVEN,
           INSERTED.CDGRPOCORPED,
           INSERTED.CDGRPOCORCAN,
           INSERTED.IDSOLOBSPED,
           INSERTED.IDSOLOBSCAN,
           INSERTED.DTULTATULOJA,
           INSERTED.CDPRODCONSUF,
           INSERTED.IDTIPCOBRA,
           INSERTED.CDCENTCUST,
           INSERTED.IDINFMESACOM,
           INSERTED.IDINFCONSCOM,
           INSERTED.IDINFVENDCOM,
           INSERTED.IDCOMANDAAUT,
           INSERTED.IDPOSOBSPED,
           INSERTED.IDBLOQCOMPARC,
           INSERTED.IDIMPCNPJCLIE,
           INSERTED.IDUTLSENHAOPER,
           INSERTED.IDIMPRCUPTEFRED,
           INSERTED.IDIMPCUPTROCA,
           INSERTED.NRDIASCUPTROCA,
           INSERTED.IDEXIBEMENSOP,
           INSERTED.DSMENSOPERLOJA
     FROM
	   INSERTED
     WHERE     
           INSERTED.CDFILIAL+INSERTED.CDLOJA NOT IN (SELECT CDFILIAL+CDLOJA FROM DELETED)

     OPEN C_CURSOR;
           FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                         @V_OLD_CDFILIAL,@V_OLD_CDLOJA,@V_OLD_NMLOJA,@V_OLD_DSDIRUNIARQ,
                                         @V_OLD_IDCONTCVALE,@V_OLD_CDALMOXARIFE,@V_OLD_CDLOCALESTOQ,@V_OLD_IDTIPOIMPDEL,
                                         @V_OLD_IDPORTIMPDEL,@V_OLD_IDEXPORTCDS,@V_OLD_NRDIAVALCVAL,@V_OLD_CDTABEPREC,
                                         @V_OLD_NRMESAPADRAO,@V_OLD_CDVENDPADRAO,@V_OLD_CDPRODCOUVER,@V_OLD_CDPRODCONSUM,
                                         @V_OLD_CDCLIENTERAT,@V_OLD_IDCOMISVENDA,@V_OLD_VRCOMISVENDA,@V_OLD_IDCOMANDAVEN,
                                         @V_OLD_IDCOUVERART,@V_OLD_IDCONSUMAMIN,@V_OLD_IDLUGARMESA,@V_OLD_IDRATEIOCOMI,
                                         @V_OLD_NRMINSEMCONS,@V_OLD_IDUTIVENDPAD,@V_OLD_IDCONTROPROD,@V_OLD_CDLOJMESPADR,
                                         @V_OLD_CDPRODCOMVEN,@V_OLD_CDGRPOCORPED,@V_OLD_CDGRPOCORCAN,@V_OLD_IDSOLOBSPED,
                                         @V_OLD_IDSOLOBSCAN,@V_OLD_DTULTATULOJA,@V_OLD_CDPRODCONSUF,@V_OLD_IDTIPCOBRA,
                                         @V_OLD_CDCENTCUST,@V_OLD_IDINFMESACOM,@V_OLD_IDINFCONSCOM,@V_OLD_IDINFVENDCOM,
                                         @V_OLD_IDCOMANDAAUT,@V_OLD_IDPOSOBSPED,@V_OLD_IDBLOQCOMPARC,@V_OLD_IDIMPCNPJCLIE,
                                         @V_OLD_IDUTLSENHAOPER,@V_OLD_IDIMPRCUPTEFRED,@V_OLD_IDIMPCUPTROCA,@V_OLD_NRDIASCUPTROCA,
                                         @V_OLD_IDEXIBEMENSOP,@V_OLD_DSMENSOPERLOJA,

                                         @V_NEW_CDFILIAL,@V_NEW_CDLOJA,@V_NEW_NMLOJA,@V_NEW_DSDIRUNIARQ,
                                         @V_NEW_IDCONTCVALE,@V_NEW_CDALMOXARIFE,@V_NEW_CDLOCALESTOQ,@V_NEW_IDTIPOIMPDEL,
                                         @V_NEW_IDPORTIMPDEL,@V_NEW_IDEXPORTCDS,@V_NEW_NRDIAVALCVAL,@V_NEW_CDTABEPREC,
                                         @V_NEW_NRMESAPADRAO,@V_NEW_CDVENDPADRAO,@V_NEW_CDPRODCOUVER,@V_NEW_CDPRODCONSUM,
                                         @V_NEW_CDCLIENTERAT,@V_NEW_IDCOMISVENDA,@V_NEW_VRCOMISVENDA,@V_NEW_IDCOMANDAVEN,
                                         @V_NEW_IDCOUVERART,@V_NEW_IDCONSUMAMIN,@V_NEW_IDLUGARMESA,@V_NEW_IDRATEIOCOMI,
                                         @V_NEW_NRMINSEMCONS,@V_NEW_IDUTIVENDPAD,@V_NEW_IDCONTROPROD,@V_NEW_CDLOJMESPADR,
                                         @V_NEW_CDPRODCOMVEN,@V_NEW_CDGRPOCORPED,@V_NEW_CDGRPOCORCAN,@V_NEW_IDSOLOBSPED,
                                         @V_NEW_IDSOLOBSCAN,@V_NEW_DTULTATULOJA,@V_NEW_CDPRODCONSUF,@V_NEW_IDTIPCOBRA,
                                         @V_NEW_CDCENTCUST,@V_NEW_IDINFMESACOM,@V_NEW_IDINFCONSCOM,@V_NEW_IDINFVENDCOM,
                                         @V_NEW_IDCOMANDAAUT,@V_NEW_IDPOSOBSPED,@V_NEW_IDBLOQCOMPARC,@V_NEW_IDIMPCNPJCLIE,
                                         @V_NEW_IDUTLSENHAOPER,@V_NEW_IDIMPRCUPTEFRED,@V_NEW_IDIMPCUPTROCA,@V_NEW_NRDIASCUPTROCA,
                                         @V_NEW_IDEXIBEMENSOP,@V_NEW_DSMENSOPERLOJA

   WHILE (@@FETCH_STATUS = 0) BEGIN

   IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
      IF ISNULL(@V_NEW_CDFILIAL  ,'NULL') <> ISNULL(@V_OLD_CDFILIAL  ,'NULL') BEGIN 
         SET @V_DESC = 'Filial ' + ISNULL(@V_NEW_CDFILIAL ,'' );
      END;
      IF ISNULL(@V_NEW_CDLOJA ,'NULL') <> ISNULL(@V_OLD_CDLOJA ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Loja ' + ISNULL(@V_NEW_CDLOJA,'' );
      END;
      IF ISNULL(@V_NEW_NMLOJA ,'NULL') <> ISNULL(@V_OLD_NMLOJA ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nm Loja ' + ISNULL(@V_NEW_NMLOJA,'' );
      END;
      IF ISNULL(@V_NEW_DSDIRUNIARQ ,'NULL') <> ISNULL(@V_OLD_DSDIRUNIARQ ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dir Arq ' + ISNULL(@V_NEW_DSDIRUNIARQ,'' );
      END;
      IF ISNULL(@V_NEW_IDCONTCVALE ,'NULL') <> ISNULL(@V_OLD_IDCONTCVALE ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cont CVale ' + ISNULL(@V_NEW_IDCONTCVALE,'' );
      END;
      IF ISNULL(@V_NEW_CDALMOXARIFE ,'NULL') <> ISNULL(@V_OLD_CDALMOXARIFE ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDALMOXARIFE ' + ISNULL(@V_NEW_CDALMOXARIFE,'' );
      END;
      IF ISNULL(@V_NEW_CDLOCALESTOQ ,'NULL') <> ISNULL(@V_OLD_CDLOCALESTOQ ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDLOCALESTOQ ' + ISNULL(@V_NEW_CDLOCALESTOQ,'' );
      END;
      IF ISNULL(@V_NEW_IDTIPOIMPDEL ,'NULL') <> ISNULL(@V_OLD_IDTIPOIMPDEL ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPOIMPDEL ' + ISNULL(@V_NEW_IDTIPOIMPDEL,'' );
      END;
      IF ISNULL(@V_NEW_IDPORTIMPDEL ,'NULL') <> ISNULL(@V_OLD_IDPORTIMPDEL ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPORTIMPDEL ' + ISNULL(@V_NEW_IDPORTIMPDEL,'' );
      END;
      IF ISNULL(@V_NEW_IDEXPORTCDS ,'NULL') <> ISNULL(@V_OLD_IDEXPORTCDS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDEXPORTCDS ' + ISNULL(@V_NEW_IDEXPORTCDS,'' );
      END;
      IF ISNULL(@V_NEW_NRDIAVALCVAL ,'NULL') <> ISNULL(@V_OLD_NRDIAVALCVAL ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIAVALCVAL ' + ISNULL(@V_NEW_NRDIAVALCVAL,'' );
      END;
      IF ISNULL(@V_NEW_CDTABEPREC ,'NULL') <> ISNULL(@V_OLD_CDTABEPREC ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTABEPREC ' + ISNULL(@V_NEW_CDTABEPREC,'' );
      END;
      IF ISNULL(@V_NEW_NRMESAPADRAO ,'NULL') <> ISNULL(@V_OLD_NRMESAPADRAO ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRMESAPADRAO ' + ISNULL(@V_NEW_NRMESAPADRAO,'' );
      END;
      IF ISNULL(@V_NEW_CDVENDPADRAO ,'NULL') <> ISNULL(@V_OLD_CDVENDPADRAO ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDVENDPADRAO ' + ISNULL(@V_NEW_CDVENDPADRAO,'' );
      END;
      IF ISNULL(@V_NEW_CDPRODCOUVER ,'NULL') <> ISNULL(@V_OLD_CDPRODCOUVER ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCOUVER ' + ISNULL(@V_NEW_CDPRODCOUVER,'' );
      END;
      IF ISNULL(@V_NEW_CDPRODCONSUM ,'NULL') <> ISNULL(@V_OLD_CDPRODCONSUM ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCONSUM ' + ISNULL(@V_NEW_CDPRODCONSUM,'' );
      END;
      IF ISNULL(@V_NEW_CDCLIENTERAT ,'NULL') <> ISNULL(@V_OLD_CDCLIENTERAT ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCLIENTERAT ' + ISNULL(@V_NEW_CDCLIENTERAT,'' );
      END;
      IF ISNULL(@V_NEW_IDCOMISVENDA ,'NULL') <> ISNULL(@V_OLD_IDCOMISVENDA ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMISVENDA ' + ISNULL(@V_NEW_IDCOMISVENDA,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRCOMISVENDA) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRCOMISVENDA) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' VRCOMISVENDA ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRCOMISVENDA),'' );
      END;
      IF ISNULL(@V_NEW_IDCOMANDAVEN ,'NULL') <> ISNULL(@V_OLD_IDCOMANDAVEN ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMANDAVEN ' + ISNULL(@V_NEW_IDCOMANDAVEN,'' );
      END;
      IF ISNULL(@V_NEW_IDCOUVERART ,'NULL') <> ISNULL(@V_OLD_IDCOUVERART ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOUVERART ' + ISNULL(@V_NEW_IDCOUVERART,'' );
      END;
      IF ISNULL(@V_NEW_IDCONSUMAMIN ,'NULL') <> ISNULL(@V_OLD_IDCONSUMAMIN ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCONSUMAMIN ' + ISNULL(@V_NEW_IDCONSUMAMIN,'' );
      END;
      IF ISNULL(@V_NEW_IDLUGARMESA ,'NULL') <> ISNULL(@V_OLD_IDLUGARMESA ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDLUGARMESA ' + ISNULL(@V_NEW_IDLUGARMESA,'' );
      END;
      IF ISNULL(@V_NEW_IDRATEIOCOMI ,'NULL') <> ISNULL(@V_OLD_IDRATEIOCOMI ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDRATEIOCOMI ' + ISNULL(@V_NEW_IDRATEIOCOMI,'' );
      END;
      IF ISNULL(@V_NEW_NRMINSEMCONS ,'NULL') <> ISNULL(@V_OLD_NRMINSEMCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRMINSEMCONS ' + ISNULL(@V_NEW_NRMINSEMCONS,'' );
      END;
      IF ISNULL(@V_NEW_IDUTIVENDPAD ,'NULL') <> ISNULL(@V_OLD_IDUTIVENDPAD ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTIVENDPAD ' + ISNULL(@V_NEW_IDUTIVENDPAD,'' );
      END;
      IF ISNULL(@V_NEW_IDCONTROPROD ,'NULL') <> ISNULL(@V_OLD_IDCONTROPROD ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCONTROPROD ' + ISNULL(@V_NEW_IDCONTROPROD,'' );
      END;
      IF ISNULL(@V_NEW_CDLOJMESPADR ,'NULL') <> ISNULL(@V_OLD_CDLOJMESPADR ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDLOJMESPADR ' + ISNULL(@V_NEW_CDLOJMESPADR,'' );
      END;
      IF ISNULL(@V_NEW_CDPRODCOMVEN ,'NULL') <> ISNULL(@V_OLD_CDPRODCOMVEN ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCOMVEN ' + ISNULL(@V_NEW_CDPRODCOMVEN,'' );
      END;
      IF ISNULL(@V_NEW_CDGRPOCORPED ,'NULL') <> ISNULL(@V_OLD_CDGRPOCORPED ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDGRPOCORPED ' + ISNULL(@V_NEW_CDGRPOCORPED,'' );
      END;
      IF ISNULL(@V_NEW_CDGRPOCORCAN ,'NULL') <> ISNULL(@V_OLD_CDGRPOCORCAN ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDGRPOCORCAN ' + ISNULL(@V_NEW_CDGRPOCORCAN,'' );
      END;
      IF ISNULL(@V_NEW_IDSOLOBSPED ,'NULL') <> ISNULL(@V_OLD_IDSOLOBSPED ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSOLOBSPED ' + ISNULL(@V_NEW_IDSOLOBSPED,'' );
      END;
      IF ISNULL(@V_NEW_IDSOLOBSCAN ,'NULL') <> ISNULL(@V_OLD_IDSOLOBSCAN ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSOLOBSCAN ' + ISNULL(@V_NEW_IDSOLOBSCAN,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATULOJA) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTATULOJA) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' DTULTATULOJA ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATULOJA),'' );
      END;
      IF ISNULL(@V_NEW_CDPRODCONSUF ,'NULL') <> ISNULL(@V_OLD_CDPRODCONSUF ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCONSUF ' + ISNULL(@V_NEW_CDPRODCONSUF,'' );
      END;
      IF ISNULL(@V_NEW_IDTIPCOBRA ,'NULL') <> ISNULL(@V_OLD_IDTIPCOBRA ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPCOBRA ' + ISNULL(@V_NEW_IDTIPCOBRA,'' );
      END;
      IF ISNULL(@V_NEW_CDCENTCUST ,'NULL') <> ISNULL(@V_OLD_CDCENTCUST ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCENTCUST ' + ISNULL(@V_NEW_CDCENTCUST,'' );
      END;
      IF ISNULL(@V_NEW_IDINFMESACOM ,'NULL') <> ISNULL(@V_OLD_IDINFMESACOM ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFMESACOM ' + ISNULL(@V_NEW_IDINFMESACOM,'' );
      END;
      IF ISNULL(@V_NEW_IDINFCONSCOM ,'NULL') <> ISNULL(@V_OLD_IDINFCONSCOM ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFCONSCOM ' + ISNULL(@V_NEW_IDINFCONSCOM,'' );
      END;
      IF ISNULL(@V_NEW_IDINFVENDCOM ,'NULL') <> ISNULL(@V_OLD_IDINFVENDCOM ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFVENDCOM ' + ISNULL(@V_NEW_IDINFVENDCOM,'' );
      END;
      IF ISNULL(@V_NEW_IDCOMANDAAUT ,'NULL') <> ISNULL(@V_OLD_IDCOMANDAAUT ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMANDAAUT ' + ISNULL(@V_NEW_IDCOMANDAAUT,'' );
      END;
      IF ISNULL(@V_NEW_IDPOSOBSPED ,'NULL') <> ISNULL(@V_OLD_IDPOSOBSPED ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPOSOBSPED ' + ISNULL(@V_NEW_IDPOSOBSPED,'' );
      END;
      IF ISNULL(@V_NEW_IDBLOQCOMPARC ,'NULL') <> ISNULL(@V_OLD_IDBLOQCOMPARC ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDBLOQCOMPARC ' + ISNULL(@V_NEW_IDBLOQCOMPARC,'' );
      END;
      IF ISNULL(@V_NEW_IDIMPCNPJCLIE ,'NULL') <> ISNULL(@V_OLD_IDIMPCNPJCLIE ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPCNPJCLIE ' + ISNULL(@V_NEW_IDIMPCNPJCLIE,'' );
      END;
      IF ISNULL(@V_NEW_IDUTLSENHAOPER ,'NULL') <> ISNULL(@V_OLD_IDUTLSENHAOPER ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTLSENHAOPER ' + ISNULL(@V_NEW_IDUTLSENHAOPER,'' );
      END;
      IF ISNULL(@V_NEW_IDIMPRCUPTEFRED ,'NULL') <> ISNULL(@V_OLD_IDIMPRCUPTEFRED ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPRCUPTEFRED ' + ISNULL(@V_NEW_IDIMPRCUPTEFRED,'' );
      END;
      IF ISNULL(@V_NEW_IDIMPCUPTROCA ,'NULL') <> ISNULL(@V_OLD_IDIMPCUPTROCA ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPCUPTROCA ' + ISNULL(@V_NEW_IDIMPCUPTROCA,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_NRDIASCUPTROCA) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_NRDIASCUPTROCA) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIASCUPTROCA ' + ISNULL(CONVERT(VARCHAR,@V_NEW_NRDIASCUPTROCA),'' );
      END;
      SET @V_IDTIPOOPER = '2';
   END;
   IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
      IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
         SET @V_DESC = 'Filial ' + ISNULL(@V_NEW_CDFILIAL ,'' );
      END;
      IF @V_NEW_CDLOJA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Loja ' + ISNULL(@V_NEW_CDLOJA,'' );
      END;
      IF @V_NEW_NMLOJA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nm Loja ' + ISNULL(@V_NEW_NMLOJA,'' );
      END;
      IF @V_NEW_DSDIRUNIARQ IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' DSDIRUNIARQ ' + ISNULL(@V_NEW_DSDIRUNIARQ,'' );
      END;
      IF @V_NEW_IDCONTCVALE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCONTCVALE ' + ISNULL(@V_NEW_IDCONTCVALE,'' );
      END;
      IF @V_NEW_CDALMOXARIFE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDALMOXARIFE ' + ISNULL(@V_NEW_CDALMOXARIFE,'' );
      END;
      IF @V_NEW_CDLOCALESTOQ IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDLOCALESTOQ ' + ISNULL(@V_NEW_CDLOCALESTOQ,'' );
      END;
      IF @V_NEW_IDTIPOIMPDEL IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPOIMPDEL ' + ISNULL(@V_NEW_IDTIPOIMPDEL,'' );
      END;
      IF @V_NEW_IDPORTIMPDEL IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPORTIMPDEL ' + ISNULL(@V_NEW_IDPORTIMPDEL,'' );
      END;
      IF @V_NEW_IDEXPORTCDS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDEXPORTCDS ' + ISNULL(@V_NEW_IDEXPORTCDS,'' );
      END;
      IF @V_NEW_NRDIAVALCVAL IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIAVALCVAL ' + ISNULL(@V_NEW_NRDIAVALCVAL,'' );
      END;
      IF @V_NEW_CDTABEPREC IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTABEPREC ' + ISNULL(@V_NEW_CDTABEPREC,'' );
      END;
      IF @V_NEW_NRMESAPADRAO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRMESAPADRAO ' + ISNULL(@V_NEW_NRMESAPADRAO,'' );
      END;
      IF @V_NEW_CDVENDPADRAO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDVENDPADRAO ' + ISNULL(@V_NEW_CDVENDPADRAO,'' );
      END;
      IF @V_NEW_CDPRODCOUVER IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCOUVER ' + ISNULL(@V_NEW_CDPRODCOUVER,'' );
      END;
      IF @V_NEW_CDPRODCONSUM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCONSUM ' + ISNULL(@V_NEW_CDPRODCONSUM,'' );
      END;
      IF @V_NEW_CDCLIENTERAT IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCLIENTERAT ' + ISNULL(@V_NEW_CDCLIENTERAT,'' );
      END;
      IF @V_NEW_IDCOMISVENDA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMISVENDA ' + ISNULL(@V_NEW_IDCOMISVENDA,'' );
      END;
      IF @V_NEW_VRCOMISVENDA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' VRCOMISVENDA ' + CONVERT(VARCHAR,@V_NEW_VRCOMISVENDA);
      END;
      IF @V_NEW_IDCOMANDAVEN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMANDAVEN ' + ISNULL(@V_NEW_IDCOMANDAVEN,'' );
      END;
      IF @V_NEW_IDCOUVERART IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOUVERART ' + ISNULL(@V_NEW_IDCOUVERART,'' );
      END;
      IF @V_NEW_IDCONSUMAMIN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCONSUMAMIN ' + ISNULL(@V_NEW_IDCONSUMAMIN,'' );
      END;
      IF @V_NEW_IDLUGARMESA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDLUGARMESA ' + ISNULL(@V_NEW_IDLUGARMESA,'' );
      END;
      IF @V_NEW_IDRATEIOCOMI IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDRATEIOCOMI ' + ISNULL(@V_NEW_IDRATEIOCOMI,'' );
      END;
      IF @V_NEW_NRMINSEMCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRMINSEMCONS ' + ISNULL(@V_NEW_NRMINSEMCONS,'' );
      END;
      IF @V_NEW_IDUTIVENDPAD IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTIVENDPAD ' + ISNULL(@V_NEW_IDUTIVENDPAD,'' );
      END;
      IF @V_NEW_IDCONTROPROD IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCONTROPROD ' + ISNULL(@V_NEW_IDCONTROPROD,'' );
      END;
      IF @V_NEW_CDLOJMESPADR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDLOJMESPADR ' + ISNULL(@V_NEW_CDLOJMESPADR,'' );
      END;
      IF @V_NEW_CDPRODCOMVEN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCOMVEN ' + ISNULL(@V_NEW_CDPRODCOMVEN,'' );
      END;
      IF @V_NEW_CDGRPOCORPED IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDGRPOCORPED ' + ISNULL(@V_NEW_CDGRPOCORPED,'' );
      END;
      IF @V_NEW_CDGRPOCORCAN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDGRPOCORCAN ' + ISNULL(@V_NEW_CDGRPOCORCAN,'' );
      END;
      IF @V_NEW_IDSOLOBSPED IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSOLOBSPED ' + ISNULL(@V_NEW_IDSOLOBSPED,'' );
      END;
      IF @V_NEW_IDSOLOBSCAN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSOLOBSCAN ' + ISNULL(@V_NEW_IDSOLOBSCAN,'' );
      END;
      IF @V_NEW_DTULTATULOJA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' DTULTATULOJA ' + CONVERT(VARCHAR,@V_NEW_DTULTATULOJA);
      END;
      IF @V_NEW_CDPRODCONSUF IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCONSUF ' + ISNULL(@V_NEW_CDPRODCONSUF,'' );
      END;
      IF @V_NEW_IDTIPCOBRA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPCOBRA ' + ISNULL(@V_NEW_IDTIPCOBRA,'' );
      END;
      IF @V_NEW_CDCENTCUST IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCENTCUST ' + ISNULL(@V_NEW_CDCENTCUST,'' );
      END;
      IF @V_NEW_IDINFMESACOM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFMESACOM ' + ISNULL(@V_NEW_IDINFMESACOM,'' );
      END;
      IF @V_NEW_IDINFCONSCOM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFCONSCOM ' + ISNULL(@V_NEW_IDINFCONSCOM,'' );
      END;
      IF @V_NEW_IDINFVENDCOM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFVENDCOM ' + ISNULL(@V_NEW_IDINFVENDCOM,'' );
      END;
      IF @V_NEW_IDCOMANDAAUT IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMANDAAUT ' + ISNULL(@V_NEW_IDCOMANDAAUT,'' );
      END;
      IF @V_NEW_IDPOSOBSPED IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPOSOBSPED ' + ISNULL(@V_NEW_IDPOSOBSPED,'' );
      END;
      IF @V_NEW_IDBLOQCOMPARC IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDBLOQCOMPARC ' + ISNULL(@V_NEW_IDBLOQCOMPARC,'' );
      END;
      IF @V_NEW_IDIMPCNPJCLIE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPCNPJCLIE ' + ISNULL(@V_NEW_IDIMPCNPJCLIE,'' );
      END;
      IF @V_NEW_IDUTLSENHAOPER IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTLSENHAOPER ' + ISNULL(@V_NEW_IDUTLSENHAOPER,'' );
      END;
      IF @V_NEW_IDIMPRCUPTEFRED IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPRCUPTEFRED ' + ISNULL(@V_NEW_IDIMPRCUPTEFRED,'' );
      END;
      IF @V_NEW_IDIMPCUPTROCA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPCUPTROCA ' + ISNULL(@V_NEW_IDIMPCUPTROCA,'' );
      END;
      IF @V_NEW_NRDIASCUPTROCA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIASCUPTROCA ' + CONVERT(VARCHAR,@V_NEW_NRDIASCUPTROCA);
      END;
      SET @V_IDTIPOOPER = '1';
   END;
   IF @V_ID_COMANDO= 'D' /*DELEO*/ BEGIN
      IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
         SET @V_DESC = 'Filial ' + ISNULL(@V_OLD_CDFILIAL ,'' );
      END;
      IF @V_OLD_CDLOJA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Loja ' + ISNULL(@V_OLD_CDLOJA,'' );
      END;
      IF @V_OLD_NMLOJA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nm Loja ' + ISNULL(@V_OLD_NMLOJA,'' );
      END;
      IF @V_OLD_DSDIRUNIARQ IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' DSDIRUNIARQ ' + ISNULL(@V_OLD_DSDIRUNIARQ,'' );
      END;
      IF @V_OLD_IDCONTCVALE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCONTCVALE ' + ISNULL(@V_OLD_IDCONTCVALE,'' );
      END;
      IF @V_OLD_CDALMOXARIFE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDALMOXARIFE ' + ISNULL(@V_OLD_CDALMOXARIFE,'' );
      END;
      IF @V_OLD_CDLOCALESTOQ IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDLOCALESTOQ ' + ISNULL(@V_OLD_CDLOCALESTOQ,'' );
      END;
      IF @V_OLD_IDTIPOIMPDEL IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPOIMPDEL ' + ISNULL(@V_OLD_IDTIPOIMPDEL,'' );
      END;
      IF @V_OLD_IDPORTIMPDEL IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPORTIMPDEL ' + ISNULL(@V_OLD_IDPORTIMPDEL,'' );
      END;
      IF @V_OLD_IDEXPORTCDS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDEXPORTCDS ' + ISNULL(@V_OLD_IDEXPORTCDS,'' );
      END;
      IF @V_OLD_NRDIAVALCVAL IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIAVALCVAL ' + ISNULL(@V_OLD_NRDIAVALCVAL,'' );
      END;
      IF @V_OLD_CDTABEPREC IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDTABEPREC ' + ISNULL(@V_OLD_CDTABEPREC,'' );
      END;
      IF @V_OLD_NRMESAPADRAO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRMESAPADRAO ' + ISNULL(@V_OLD_NRMESAPADRAO,'' );
      END;
      IF @V_OLD_CDVENDPADRAO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDVENDPADRAO ' + ISNULL(@V_OLD_CDVENDPADRAO,'' );
      END;
      IF @V_OLD_CDPRODCOUVER IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCOUVER ' + ISNULL(@V_OLD_CDPRODCOUVER,'' );
      END;
      IF @V_OLD_CDPRODCONSUM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCONSUM ' + ISNULL(@V_OLD_CDPRODCONSUM,'' );
      END;
      IF @V_OLD_CDCLIENTERAT IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCLIENTERAT ' + ISNULL(@V_OLD_CDCLIENTERAT,'' );
      END;
      IF @V_OLD_IDCOMISVENDA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMISVENDA ' + ISNULL(@V_OLD_IDCOMISVENDA,'' );
      END;
      IF @V_OLD_VRCOMISVENDA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' VRCOMISVENDA ' + CONVERT(VARCHAR,@V_OLD_VRCOMISVENDA);
      END;
      IF @V_OLD_IDCOMANDAVEN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMANDAVEN ' + ISNULL(@V_OLD_IDCOMANDAVEN,'' );
      END;
      IF @V_OLD_IDCOUVERART IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOUVERART ' + ISNULL(@V_OLD_IDCOUVERART,'' );
      END;
      IF @V_OLD_IDCONSUMAMIN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCONSUMAMIN ' + ISNULL(@V_OLD_IDCONSUMAMIN,'' );
      END;
      IF @V_OLD_IDLUGARMESA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDLUGARMESA ' + ISNULL(@V_OLD_IDLUGARMESA,'' );
      END;
      IF @V_OLD_IDRATEIOCOMI IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDRATEIOCOMI ' + ISNULL(@V_OLD_IDRATEIOCOMI,'' );
      END;
      IF @V_OLD_NRMINSEMCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRMINSEMCONS ' + ISNULL(@V_OLD_NRMINSEMCONS,'' );
      END;
      IF @V_OLD_IDUTIVENDPAD IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTIVENDPAD ' + ISNULL(@V_OLD_IDUTIVENDPAD,'' );
      END;
      IF @V_OLD_IDCONTROPROD IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCONTROPROD ' + ISNULL(@V_OLD_IDCONTROPROD,'' );
      END;
      IF @V_OLD_CDLOJMESPADR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDLOJMESPADR ' + ISNULL(@V_OLD_CDLOJMESPADR,'' );
      END;
      IF @V_OLD_CDPRODCOMVEN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCOMVEN ' + ISNULL(@V_OLD_CDPRODCOMVEN,'' );
      END;
      IF @V_OLD_CDGRPOCORPED IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDGRPOCORPED ' + ISNULL(@V_OLD_CDGRPOCORPED,'' );
      END;
      IF @V_OLD_CDGRPOCORCAN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDGRPOCORCAN ' + ISNULL(@V_OLD_CDGRPOCORCAN,'' );
      END;
      IF @V_OLD_IDSOLOBSPED IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSOLOBSPED ' + ISNULL(@V_OLD_IDSOLOBSPED,'' );
      END;
      IF @V_OLD_IDSOLOBSCAN IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDSOLOBSCAN ' + ISNULL(@V_OLD_IDSOLOBSCAN,'' );
      END;
      IF @V_OLD_DTULTATULOJA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' DTULTATULOJA ' +CONVERT(VARCHAR,@V_OLD_DTULTATULOJA);
      END;
      IF @V_OLD_CDPRODCONSUF IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDPRODCONSUF ' + ISNULL(@V_OLD_CDPRODCONSUF,'' );
      END;
      IF @V_OLD_IDTIPCOBRA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDTIPCOBRA ' + ISNULL(@V_OLD_IDTIPCOBRA,'' );
      END;
      IF @V_OLD_CDCENTCUST IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' CDCENTCUST ' + ISNULL(@V_OLD_CDCENTCUST,'' );
      END;
      IF @V_OLD_IDINFMESACOM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFMESACOM ' + ISNULL(@V_OLD_IDINFMESACOM,'' );
      END;
      IF @V_OLD_IDINFCONSCOM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFCONSCOM ' + ISNULL(@V_OLD_IDINFCONSCOM,'' );
      END;
      IF @V_OLD_IDINFVENDCOM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDINFVENDCOM ' + ISNULL(@V_OLD_IDINFVENDCOM,'' );
      END;
      IF @V_OLD_IDCOMANDAAUT IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDCOMANDAAUT ' + ISNULL(@V_OLD_IDCOMANDAAUT,'' );
      END;
      IF @V_OLD_IDPOSOBSPED IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDPOSOBSPED ' + ISNULL(@V_OLD_IDPOSOBSPED,'' );
      END;
      IF @V_OLD_IDBLOQCOMPARC IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDBLOQCOMPARC ' + ISNULL(@V_OLD_IDBLOQCOMPARC,'' );
      END;
      IF @V_OLD_IDIMPCNPJCLIE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPCNPJCLIE ' + ISNULL(@V_OLD_IDIMPCNPJCLIE,'' );
      END;
      IF @V_OLD_IDUTLSENHAOPER IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDUTLSENHAOPER ' + ISNULL(@V_OLD_IDUTLSENHAOPER,'' );
      END;
      IF @V_OLD_IDIMPRCUPTEFRED IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPRCUPTEFRED ' + ISNULL(@V_OLD_IDIMPRCUPTEFRED,'' );
      END;
      IF @V_OLD_IDIMPCUPTROCA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' IDIMPCUPTROCA ' + ISNULL(@V_OLD_IDIMPCUPTROCA,'' );
      END;
      IF @V_OLD_NRDIASCUPTROCA IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' NRDIASCUPTROCA ' + CONVERT(VARCHAR,@V_OLD_NRDIASCUPTROCA);
      END;
      SET @V_IDTIPOOPER = '3';
   END;
	IF  (@V_IDTIPOOPER <> '') BEGIN
            IF @V_DESC IS NOT NULL BEGIN
               SET @V_ITPESQ =  ISNULL(@V_NEW_CDFILIAL + @V_NEW_CDLOJA,@V_OLD_CDFILIAL + @V_OLD_CDLOJA);
   	       SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
               INSERT INTO LOGOPERAVND
      	              (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                       CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                       CDORESPOPERVND, CDFILLOGOPERVND)
               VALUES ('LOJA',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                       @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER,
                       ISNULL(@V_NEW_CDFILIAL,@V_OLD_CDFILIAL));
            END;
        END;
	   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                         @V_OLD_CDFILIAL,@V_OLD_CDLOJA,@V_OLD_NMLOJA,@V_OLD_DSDIRUNIARQ,
                                         @V_OLD_IDCONTCVALE,@V_OLD_CDALMOXARIFE,@V_OLD_CDLOCALESTOQ,@V_OLD_IDTIPOIMPDEL,
                                         @V_OLD_IDPORTIMPDEL,@V_OLD_IDEXPORTCDS,@V_OLD_NRDIAVALCVAL,@V_OLD_CDTABEPREC,
                                         @V_OLD_NRMESAPADRAO,@V_OLD_CDVENDPADRAO,@V_OLD_CDPRODCOUVER,@V_OLD_CDPRODCONSUM,
                                         @V_OLD_CDCLIENTERAT,@V_OLD_IDCOMISVENDA,@V_OLD_VRCOMISVENDA,@V_OLD_IDCOMANDAVEN,
                                         @V_OLD_IDCOUVERART,@V_OLD_IDCONSUMAMIN,@V_OLD_IDLUGARMESA,@V_OLD_IDRATEIOCOMI,
                                         @V_OLD_NRMINSEMCONS,@V_OLD_IDUTIVENDPAD,@V_OLD_IDCONTROPROD,@V_OLD_CDLOJMESPADR,
                                         @V_OLD_CDPRODCOMVEN,@V_OLD_CDGRPOCORPED,@V_OLD_CDGRPOCORCAN,@V_OLD_IDSOLOBSPED,
                                         @V_OLD_IDSOLOBSCAN,@V_OLD_DTULTATULOJA,@V_OLD_CDPRODCONSUF,@V_OLD_IDTIPCOBRA,
                                         @V_OLD_CDCENTCUST,@V_OLD_IDINFMESACOM,@V_OLD_IDINFCONSCOM,@V_OLD_IDINFVENDCOM,
                                         @V_OLD_IDCOMANDAAUT,@V_OLD_IDPOSOBSPED,@V_OLD_IDBLOQCOMPARC,@V_OLD_IDIMPCNPJCLIE,
                                         @V_OLD_IDUTLSENHAOPER,@V_OLD_IDIMPRCUPTEFRED,@V_OLD_IDIMPCUPTROCA,@V_OLD_NRDIASCUPTROCA,
                                         @V_OLD_IDEXIBEMENSOP,@V_OLD_DSMENSOPERLOJA,

                                         @V_NEW_CDFILIAL,@V_NEW_CDLOJA,@V_NEW_NMLOJA,@V_NEW_DSDIRUNIARQ,
                                         @V_NEW_IDCONTCVALE,@V_NEW_CDALMOXARIFE,@V_NEW_CDLOCALESTOQ,@V_NEW_IDTIPOIMPDEL,
                                         @V_NEW_IDPORTIMPDEL,@V_NEW_IDEXPORTCDS,@V_NEW_NRDIAVALCVAL,@V_NEW_CDTABEPREC,
                                         @V_NEW_NRMESAPADRAO,@V_NEW_CDVENDPADRAO,@V_NEW_CDPRODCOUVER,@V_NEW_CDPRODCONSUM,
                                         @V_NEW_CDCLIENTERAT,@V_NEW_IDCOMISVENDA,@V_NEW_VRCOMISVENDA,@V_NEW_IDCOMANDAVEN,
                                         @V_NEW_IDCOUVERART,@V_NEW_IDCONSUMAMIN,@V_NEW_IDLUGARMESA,@V_NEW_IDRATEIOCOMI,
                                         @V_NEW_NRMINSEMCONS,@V_NEW_IDUTIVENDPAD,@V_NEW_IDCONTROPROD,@V_NEW_CDLOJMESPADR,
                                         @V_NEW_CDPRODCOMVEN,@V_NEW_CDGRPOCORPED,@V_NEW_CDGRPOCORCAN,@V_NEW_IDSOLOBSPED,
                                         @V_NEW_IDSOLOBSCAN,@V_NEW_DTULTATULOJA,@V_NEW_CDPRODCONSUF,@V_NEW_IDTIPCOBRA,
                                         @V_NEW_CDCENTCUST,@V_NEW_IDINFMESACOM,@V_NEW_IDINFCONSCOM,@V_NEW_IDINFVENDCOM,
                                         @V_NEW_IDCOMANDAAUT,@V_NEW_IDPOSOBSPED,@V_NEW_IDBLOQCOMPARC,@V_NEW_IDIMPCNPJCLIE,
                                         @V_NEW_IDUTLSENHAOPER,@V_NEW_IDIMPRCUPTEFRED,@V_NEW_IDIMPCUPTROCA,@V_NEW_NRDIASCUPTROCA,
                                         @V_NEW_IDEXIBEMENSOP,@V_NEW_DSMENSOPERLOJA
   SET @V_DESC   = '';
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;    
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_LOJA','5.20.001';
GO 